ADUMP:  ORG 00100H    ; LOADING ADDRESS
;
;
; <;>  ROUTINE TO DUMP ASCII EQUIVALENT OF MEMORY.
; MODIFIED VERSION OF DUMP ROUTINE FROM SOLOS (TM)
; COPYRIGHT 1977 BY PROCESSOR TECHNOLOGY CORP.
;      MODIFIED BY DON VAN DYKE
;** DR. DOBBS JOURNAL # 21 (VOL.3, ISSUE 1)
;
;
DUMP:  CALL SCONV     ; SCAN TO 1ST ADDRESS & CONVERT IT
       PUSH H         ; SAVE THE VALUE
       CALL PSCAN     ; SEE IF SECOND WAS GIVEN
       POP  D         ; GET BACK START
       XCHG           ; "HL" HAS STARTLT1LF; "DE" HAS END
DLOOP: CALL CRLF
       CALL ADOUT     ; OUTPUT ADDRESS
       CALL BOUT      ; ANOTHER SPACE TO KEEP IT PRETTY
       MVI  C,16      ; VALUES PER LINE
DLP1:  MOV  A,M       ; GET THE CHR
       PUSH B         ; SAVE VALUE COUNT
       CPI  20H       ; < 20H ?
       JNC  DOWN
       MVI  A,'.'     ; ...YES, MAKE IT A DOT
DOWN:  CPI  7FH       ; >= 7FH ?
       JC   DN1       ; ...NO
       MVI  A,'.'     ; ...YES,MAKE THIS A DOT
DN1:   MOV  B,A       ; PUT IT IN "B"
       CALL SOUT      ; PUT IT OUT
       MVI  B,' '
       CALL SOUT      ; PUT OUT A BLANK
       MOV  A,L       ; COMPARE "DE" & "HL"
       SUB  E
       MOV  A,H
       SBB  D
       JNC  COMND     ; ALL DONE
       POP  B         ; VALUES PER LINE
       INX  H
       DCR  C         ; BUMP THE LINE COUNT
       JNZ  DLP1      ; NOT ZERO IF MORE FOR THIS LINE
       JMP  DLOOP     ; DO A LFCR BEFORE THE NEXT
SOUT   EQU  0C019H    ; SYSTEM ENTRY POINT: OUTPUT PORT
SCONV  EQU  0C33AH    ;    "   ROUTINE: CONV CHAR. 2 HEX
COMND  EQU  0C1C9H    ;    "      "   : PROCESS COMMANDS
ADOUT  EQU  0C3E8H    ; " ": OUTPUT 'HL' AS HEX 16 BIT VAL
BOUT   EQU  0C406H    ; PART OF ABOVE ROUTINE
PSCAN  EQU  0C310H    ; SYS. ROUTINE: SCAN OFF OPT. PARAM.
CRLF   EQU  0C2F9H    ; " ": OUTPUT LINE FEED & CARR. RET.
ENDIT:      END
;

